<?php
/**
 * @author MahaCOD Programming Team
 * @copyright www.mahacod.ir
 * 
 */
class MAHACOD extends Module{
	public $prefix;
	private $wsdl_address  = "http://webservice.cod.local/cod.wsdl";
	public function __construct(){
		$this->name = 'mahacod';
		$this->tab = 'others';
		$this->version = '1.0';
		$this->prefix = $this->prefix;
		$this->author = 'MahaCOD';
		$this->need_instance = 0;
		parent::__construct();
		$this->displayName = $this->l('mahacod');
		$this->description = $this->l('Mahacod Webservice');
		require_once (_PS_MODULE_DIR_ . $this->name . '/models/mahacod.class.php');
		$this->confirmUninstall = $this->l('Are you sure you want to uninstall?');
	}
	/*********************************************************************************/
    public function install(){
        require (_PS_MODULE_DIR_ . 'mahacod_payment/mahacod_payment.php');
        require (_PS_MODULE_DIR_ . 'mahacod_carrier/mahacod_carrier.php');
        $payment = new MahaCOD_Payment();
        $carrier = new MahaCOD_Carrier();
        if (!$payment->install() or !$carrier->install()){ return false; }
        if (!$this->installConfig()){ return false; }
        if (!parent::install() 
			or !$this->registerHook('displayShoppingCartFooter') 
			or !$this->registerHook('actionProductUpdate')
			or !$this->alterTable('add')			
			or !$this->registerHook('actionAdminControllerSetMedia')
			or !$this->registerHook('actionProductUpdate')
			or !$this->registerHook('displayAdminProductsExtra')
			or !$this->addnewState())
		{ return false; }
        if (!$this->installDb()){ return false; }
        return true;
    }
	/*********************************************************************************/
    public function uninstall(){
        require (_PS_MODULE_DIR_ . 'mahacod_payment/mahacod_payment.php');
        require (_PS_MODULE_DIR_ . 'mahacod_carrier/mahacod_carrier.php');
        $payment = new MahaCOD_Payment();
        $carrier = new MahaCOD_Carrier();
        $payment->uninstall();
		$carrier->uninstall();
        if (!$this->uninstallDb()){return false;}
        if (!$this->uninstallConfig()){return false;}
        if (!$this->removeState()){return false;}
        if (!parent::uninstall() or !$this->alterTable('remove')){return false;}
        return true;
    }
	/*********************************************************************************/
    public function installConfig(){
        if (!Configuration::updateValue($this->prefix . '_USERNAME','') 
		or !Configuration::updateValue($this->prefix . '_PASSWORD','')
		or !Configuration::updateValue('MAHACOD_SEND_STATUS','')
		or !Configuration::updateValue('MAHACOD_ERROR_STATUS','')){ return false; }
        return true;
    }
	/*********************************************************************************/
    public function uninstallConfig(){
        if (!Configuration::deleteByName($this->prefix . '_USERNAME') 
		or !Configuration::deleteByName($this->prefix . '_PASSWORD')
		or !Configuration::deleteByName('MAHACOD_SEND_STATUS')
		or !Configuration::deleteByName('MAHACOD_ERROR_STATUS')){ return false; }
        return true;
    }
	/*********************************************************************************/
    public function installDb(){
        $sql = 'CREATE TABLE IF NOT EXISTS `' . _DB_PREFIX_ . 'mahacodorder`(  
            `id_cart` INT(10) NOT NULL ,
            `id_customer` INT(10) NOT NULL,
            `orderid` VARCHAR(256) NOT NULL,
            PRIMARY KEY (`id_cart`,`id_customer`)
            )ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8';
        if (!Db::getInstance()->execute($sql)){ return false; }
        return true;
    }
	/*********************************************************************************/
    private function uninstallDb(){
        $sql &= Db::getInstance()->execute('DROP TABLE IF EXISTS `' . _DB_PREFIX_ . 'mahacodorder`');
        if (!$sql){ return false; }
        return true;
    }
	/*********************************************************************************/
	public function addnewState(){
		$orderState = new OrderState();
		$orderState->name = array();
		foreach (Language::getLanguages() AS $language){
			if (strtolower($language['iso_code']) == 'fa'){
				$orderState->name[$language['id_lang']] = 'ارسال توسط پرداخت در محل پست';
			}else{
				$orderState->name[$language['id_lang']] = 'Send By Cash On Delivery';
			}
		}
		$orderState->send_email = false;
		$orderState->color = '#ff9000';
		$orderState->hidden = false;
		$orderState->delivery = true;
		$orderState->logable = true;
		$orderState->invoice = true;
		$orderState->pdf_delivery = true;
		$orderState->pdf_invoice = true;
		if ($orderState->add()){
			Configuration::updateValue('MAHACOD_SEND_STATUS', (int)$orderState->id);
		}
		$orderState = new OrderState();
		$orderState->name = array();
		foreach (Language::getLanguages() AS $language){
			if (strtolower($language['iso_code']) == 'fa'){
				$orderState->name[$language['id_lang']] = 'خطا در هنگام ثبت در پست';
			}else{
				$orderState->name[$language['id_lang']] = 'Error Register Cash On Delivery';
			}
		}
		$orderState->send_email = false;
		$orderState->color = '#ff0000';
		$orderState->hidden = false;
		$orderState->delivery = false;
		$orderState->logable = true;
		$orderState->invoice = true;
		$orderState->pdf_delivery = false;
		$orderState->pdf_invoice = false;
		if ($orderState->add()){
			Configuration::updateValue('MAHACOD_ERROR_STATUS', (int)$orderState->id);
			return true;
		}
		return false;
	}
	/*********************************************************************************/
	public function removeState(){
		$orderState = new OrderState(Configuration::get('MAHACOD_SEND_STATUS'));        
    	$orderState->delete();
		$orderState = new OrderState(Configuration::get('MAHACOD_ERROR_STATUS'));        
    	return $orderState->delete();
	}
	/*********************************************************************************/
    public function getContent(){
        $retern = '';
        $errors = array();
        if (Tools::getValue('save')){
            if (Tools::isEmpty(Tools::getValue('username')) or Tools::isEmpty(Tools::getValue('password'))){
                $errors[] = $this->displayError($this->l('Username Or password is empty'));
			}else{
                if (!Configuration::updateValue($this->prefix . '_USERNAME',Tools::getValue('username')) 
				or !Configuration::updateValue($this->prefix . '_PASSWORD',Tools::getValue('password'))){
                   $errors[] = $this->displayError($this->l('Error in update settings try again'));
				}
            }
			$retern = ($errors and !empty($errors)) ? implode("\n",$errors) :  $this->displayConfirmation($this->l('settings is updated'));
        }
        $this->smarty->assign(array(
            'username' => Configuration::get($this->prefix . '_USERNAME'),
            'password' => Configuration::get($this->prefix . '_PASSWORD'),
            'admin_img_dir'=>_PS_ADMIN_IMG_,
            'module_path'=>$this->_path,
            'form_url' => Tools::safeOutput($_SERVER['REQUEST_URI']),
            ));
        return $retern . $this->display(__file__,'views/templates/admin/getcontent.tpl');
    }
	/*********************************************************************************/
     public function setMethod($mthod){
        $newCookie = new Cookie('mahacod');
        $newCookie->__set('payment_method',$mthod);
        return 'set';
     }
	/*********************************************************************************/
    public function hookDisplayShoppingCartFooter(){
        $this->smarty->assign(array(
            'tpldir' => _PS_MODULE_DIR_ . $this->name . '/views/templates/front',
            'jsdir' => _MODULE_DIR_ . $this->name . '/views/js/',
            'ajaxurl' => _MODULE_DIR_ . $this->name . '/views/ajax/ajaxprocess.php?secure=' . Tools::encrypt($this->name),
            'module' => $this->name));
        return $this->display(__file__,'views/templates/front/citystate.tpl');
    }
	/*********************************************************************************/
    public function getSendPrice($id_state,$id_city){
        global $cookie;
        $newCookie = new Cookie('mahacod');
        $COD = 0;
        $cookie->id_currency;
        $id_cart = Context::getContext()->cookie->id_cart;
        $ClassCart = new Cart($id_cart);
        $weight = $ClassCart->getTotalWeight();
        if ($weight == 0 || !$weight){
            $msg['error'] = $this->l('wieght of products is not valid please contact admin');
            return Tools::jsonEncode($msg);
        }
        $context = Context::getContext();
        $id_rial = Currency::getIdByIsoCode('IRR');
        $rial_currency = new Currency((int)$id_rial);
        $totalprice = $ClassCart->getOrderTotal(true,Cart::BOTH_WITHOUT_SHIPPING);
        $currentCurrency = new Currency($cookie->id_currency);
        if ($rial_currency->id != $cookie->id_currency){
            $totalprice = number_format(Tools::convertPriceFull($totalprice,$currentCurrency,$rial_currency),0,'','');
		}else{
            $totalprice = number_format($totalprice,0,'','');
		}
        /** connect to webservice */
        $username = trim(Configuration::get($this->prefix . '_USERNAME'));
        $password = trim(Configuration::get($this->prefix . '_PASSWORD'));
        try{
            $client = new soapclient($this->wsdl_address,array('login'=> $username,'password'=> $password));
        }catch (SoapFault $e){
            $msg['error'] = $this->l('error in server contact admin');
            return Tools::jsonEncode($msg);
        }
        /*-------------pishtaz method------------- */
		$ap_param = array('ostan_maghsad'=>(int)$id_state
				,'shahr_maghsad'=>(int)$id_city
				,'send_type'=> (int) 2
				,'products_weight'=>(int)$weight
				,'total_price'=>(int)($totalprice));
        try{
			$response = $client->__soapCall("calculation_send_price", $ap_param);
       }catch (SoapFault $e){
            $msg['error'] = $this->l('can not  connet to webservice');
            return Tools::jsonEncode($msg);
        }
		$pishtazCarrier =(int) $response->send_price;
        if (isset($response->error_code)){
            return Tools::jsonEncode(array($msg['error'] => $response->error_message));
		}
        $pishtazCarrier = $response->send_price+$response->khadamat;
       /*-------------sefareshi method------------- */
		$ap_param = array('ostan_maghsad'=>(int)$id_state
				,'shahr_maghsad'=>(int)$id_city
				,'send_type'=> (int) 1
				,'products_weight'=>(int)$weight
				,'total_price'=>(int)($totalprice));
       try{
            $response = $client->__soapCall("calculation_send_price", $ap_param);
        }catch (SoapFault $e){
            $msg['error'] = $this->l('can not  connet to webservice');
            return Tools::jsonEncode($msg);
        }
        if (isset($response->error_code)){
           return Tools::jsonEncde(array($msg['error'] => $response->error_message));
		}
		$sefareshiCarrier =(int) $response->send_price+$response->khadamat;
       /** try to set cookie */
        $newCookie->__set('pishtaz_carrier',$pishtazCarrier);
        $newCookie->__set('sefareshi_carrier',$sefareshiCarrier);
        $newCookie->__set('mahacod_city',$id_city);
        $newCookie->__set('mahacod_state',$id_state);
        $msg['set'] = 'set';
        return Tools::jsonEncode($msg);
    }
	/*********************************************************************************/
    public function getCarrierPrice(){
        $newCookie = new Cookie('mahacod');
        $context = Context::getContext();
        $iso_rial = Currency::getIdByIsoCode('IRR');
        $rial = new Currency($iso_rial);
        $current_currency = new Currency($context->cookie->id_currency);
       if ($current_currency->id != $rial->id){
            $sefareshi = Tools::convertPriceFull($newCookie->__get('sefareshi_carrier'),$rial,$current_currency);
            $pishtaz = Tools::convertPriceFull($newCookie->__get('pishtaz_carrier'),$rial,$current_currency);
            $msg = array(Configuration::get('MAHACOD_SEFARESHI_C_ID') => Tools::displayPrice($sefareshi,$current_currency),
						Configuration::get('MAHACOD_PISHTAZ_C_ID') => Tools::displayPrice($pishtaz,$current_currency));
        }else{
            $msg = array(Configuration::get('MAHACOD_SEFARESHI_C_ID') => Tools::displayPrice($newCookie->__get('sefareshi_carrier'),$current_currency),
						Configuration::get('MAHACOD_PISHTAZ_C_ID') => Tools::displayPrice($newCookie->__get('pishtaz_carrier'),$current_currency));
		}
        return Tools::jsonEncode($msg);
    }
	/*********************************************************************************/
	/*===========================Add Custom Fild=====================================*/
	/*********************************************************************************/
	public function alterTable($method){
		switch ($method) {
			case 'add':
				$sql = 'ALTER TABLE ' . _DB_PREFIX_ . 'product_lang ADD `mahacod_pid` TEXT NOT NULL';
			break;
			case 'remove':
				$sql = 'ALTER TABLE ' . _DB_PREFIX_ . 'product_lang DROP COLUMN `mahacod_pid`';
			break;
		}
		if(!Db::getInstance()->Execute($sql)){
			return false;
		}
		return true;
	}
	/*********************************************************************************/
	public function prepareNewTab(){
		$this->context->smarty->assign(array(
			'mahacod_pid' => $this->get_mahapid((int)Tools::getValue('id_product'),false,false),
			'languages' => $this->context->controller->_languages,
			'default_language' => (int)Configuration::get('PS_LANG_DEFAULT')
		));
	}
	/*********************************************************************************/
	public function hookDisplayAdminProductsExtra($params){
		if (Validate::isLoadedObject($product = new Product((int)Tools::getValue('id_product')))){
			$this->prepareNewTab();
			return $this->display(__FILE__, 'views/templates/admin/newfieldstut.tpl');
		}
	}	
	/*********************************************************************************/
	public function hookActionAdminControllerSetMedia($params){
		if($this->context->controller->controller_name == 'AdminProducts' && Tools::getValue('id_product')){
			$this->context->controller->addJS($this->_path.'/views/js/newfieldstut.js');
		}
	}
	/*********************************************************************************/
	public function hookActionProductUpdate($params){
		$id_product = (int)Tools::getValue('id_product');
		$languages = Language::getLanguages(true);
		foreach ($languages as $lang) {
			if(!Db::getInstance()->update('product_lang', array('mahacod_pid'=> pSQL(Tools::getValue('mahacod_pid_'.$lang['id_lang']))) ,'id_lang = ' . $lang['id_lang'] .' AND id_product = ' .$id_product ))
				$this->context->controller->_errors[] = Tools::displayError('Error: ').mysql_error();
		}
	}
	/*********************************************************************************/
	public function set_random_mahapid($id_product){
		$string=rand(1,9);
		for($i=0;$i<9;$i++){$string.=rand(0,9);}
		$result = Db::getInstance()->ExecuteS("UPDATE `"._DB_PREFIX_."product_lang` SET `mahacod_pid` = '".$string."' WHERE `id_product` = ".(int)$id_product.";");
		return ($result)?$string:false;
	}
	/*********************************************************************************/
	public function get_mahapid($id_product,$newid = true,$onlyid = true){
		$result = Db::getInstance()->ExecuteS('SELECT mahacod_pid, id_lang FROM '._DB_PREFIX_.'product_lang WHERE id_product = ' . (int)$id_product);
		if(!$result)
			if($newid){
				$fields[1] = $this->set_random_mahapid($id_product);
			}else{
				return array();
			}
		foreach ($result as $field) {
			$fields[$field['id_lang']] = $field['mahacod_pid'];
		}
		if (empty($fields[1])){
			$fields[1] = ($newid) ? $this->set_random_mahapid($id_product):'';
		}
		return ($onlyid)?$fields[1]:$fields;
	}
	/*********************************************************************************/
	/*===============================================================================*/
	/*********************************************************************************/
    public function maha_product_list() {
		$cart = $this->context->cart;
		$products = $cart->getProducts();
        $Currrency = new Currency();
        $rial_id = $Currrency->getCurrency($Currrency->getIdByIsoCode('IRR'));
        $rial = new Currency($rial_id);
        $currentCur = new Currency($cart->id_currency);
        $product_list_array = $product_str_array = array();
        foreach ($products as $product){
			$pid = $this->get_mahapid($product['id_product'],true,true);
			if ($pid!=false){
				if(isset($product_list_array[$pid])){
					$product_list_array[$pid]['quantity']++;
				}else{
					$product_list_array[$pid] = array('pid'=>$pid
					,'name'=>$product['name']
					,'weight'=>$product['weight']
					,'price'=>($rial->id!=$currentCur->id) ? (int)Tools::convertPriceFull((int)$product['price_wt'], $currentCur, $rial).';' : (int)$product['price_wt']
					,'quantity'=>$product['quantity']);
				}
			}
        }
		foreach($product_list_array as $pid=>$parr){
			$product_str_array[] = implode("^",$parr);
		}
        return implode(";",$product_str_array);
    }
	/*********************************************************************************/
    public function maha_product_attribute() {
		$cart = $this->context->cart;
		$products = $cart->getProducts();
        $product_attribute_array = array();
        foreach ($products as $product){
			$product_attribute_array[] = $product['name'].'('.$product['attributes'].')';
        }
        return implode(",",$product_attribute_array);
    }
	/*********************************************************************************/
    public function getIp(){
       if (!empty($_SERVER['HTTP_CLIENT_IP'])){
             $ip = $_SERVER['HTTP_CLIENT_IP'];
        }elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])){
            $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
        }else{
            $ip = $_SERVER['REMOTE_ADDR'];
        }
        return $ip;
    }
	/*********************************************************************************/
    private function unsetCookies(){
        $newCookie = new Cookie('mahacod');
        $newCookie->__unset('pishtaz_carrier');
        $newCookie->__unset('mahacod_state');
        $newCookie->__unset('mahacod_city');
        $newCookie->__unset('sefareshi_carrier');
        $newCookie->__unset('mahacodCarrier');
    }
	/*********************************************************************************/
    public function saveOrder(){
        $newCookie = new Cookie('mahacod');
        $classCart = new Cart((int)$this->context->cookie->id_cart);
        $classCustomer = new Customer((int)$this->context->cookie->id_customer);
        $classAddress = new Address((int)$classCart->id_address_delivery);
        $username = trim(Configuration::get($mahacod->prefix.'_USERNAME'));
        $password = trim(Configuration::get($mahacod->prefix.'_PASSWORD'));

		$ap_param = array('o_name'=>$classAddress->firstname
		,'o_family'=>$classAddress->lastname
		,'o_phone'=>$classAddress->phone
		,'o_mobile'=>$classAddress->phone_mobile
		,'o_email'=>$classCustomer->email
		,'o_postalcod'=>$classAddress->postcode
		,'o_ostan'=>$newCookie->__get('mahacod_state')
		,'o_shahr'=>$newCookie->__get('mahacod_city')
		,'o_address'=>$classAddress->address1
		,'o_message'=>$this->maha_product_attribute()
		,'o_sendtype'=>(($newCookie->__get('mahacodCarrier') == $newCookie->__get('pishtaz_carrier')) ? 2: 1)
		,'o_product_list'=>$this->maha_product_list()
		,'o_partner_code'=>0
		,'o_ip_address'=>$this->getIp()
		,'o_extra_parametr'=>'');
        try{
            $soapClient = new soapclient($this->wsdl_address,array('login'=> $username,'password'=> $password));
        }catch (SoapFault $e){
			return array('error' => $this->l('error in webservice').$message);
        }
		$myreturn = $soapClient->__soapCall("insert_order", $ap_param);
		if (!isset($myreturn->error_code)){
			Db::getInstance()->execute("INSERT INTO `"._DB_PREFIX_."mahacodorder` (`id_cart`, `id_customer`, `orderid`) 
			VALUES ('".($this->context->cookie->id_cart)."', '".($this->context->cookie->id_customer)."', '".($myreturn->order_code)."');");
			$this->unsetCookies();
			return array('orderid' => $myreturn->order_code);
		}else{
			return array('error' => $myreturn->error_message);
		}
    }
	/*********************************************************************************/
}
