<?php
class mahacod_paymentValidationModuleFrontController extends ModuleFrontController{
	public function postProcess(){
		$cart = $this->context->cart;
		if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active)
			Tools::redirect('index.php?controller=order&step=1');

		// Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
		$authorized = false;
		foreach (Module::getPaymentModules() as $module){
			if ($module['name'] == 'mahacod_payment'){
				$authorized = true;
				break;
			}
		}
		if (!$authorized){
			die($this->module->l('This payment method is not available.', 'validation'));
		}
		$customer = new Customer($cart->id_customer);
		if (!Validate::isLoadedObject($customer)){
			Tools::redirect('index.php?controller=order&step=1');
		}
		$newCookie = new Cookie('mahacod');
		$currency = $this->context->currency;
		$total = (float)$cart->getOrderTotal(true, Cart::BOTH);
        require (_PS_MODULE_DIR_.'mahacod/mahacod.php');
        $mahacod = new MahaCOD();
		$return = $mahacod->saveOrder();
		if (isset($return['orderid'])){
			$newCookie->__set('orderid',$return['orderid']);
			$this->module->validateOrder($cart->id, Configuration::get('MAHACOD_SEND_STATUS')
										, $total, $this->module->displayName, NULL, $mailVars
										, (int)$currency->id, false, $customer->secure_key);
		}else{
			$this->module->validateOrder($cart->id, Configuration::get('MAHACOD_ERROR_STATUS')
										, $total, $this->module->displayName, NULL, $mailVars
										, (int)$currency->id, false, $customer->secure_key);
			$newCookie->__set('orderid','');
			$newCookie->__set('errormsg',$return['error']);
		}
		Tools::redirect('index.php?controller=order-confirmation&id_cart='.$cart->id.'&id_module='.$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key);
	}
}
?>