<?php
/**
 * @author MahaCOD Programming Team
 * @copyright www.mahacod.ir
 * 
 */
if (!defined('_PS_VERSION_'))
  exit;
class MahaCOD_Payment extends PaymentModule{
	
    public function __construct(){
        $this->name = 'mahacod_payment';
        $this->tab = 'payments_gateways';
        $this->version = '1.0';
		$this->author = 'MahaCOD';
        $this->limited_countries = array('ir', 'us');
        $this->currencies = true;
        $this->currencies_mode = 'radio';
		$this->context = Context::getContext();
        parent::__construct();
        $this->displayName = $this->l('Mahacod Payment Service');
        $this->description = $this->l('Mahacod Webservice');
  }
	/*********************************************************************************/
    public function install() {
        if (!parent::install()){ return false; }
        if (!$this->registerHook('payment') || !$this->registerHook('paymentReturn')){ return false; }
        return true;
    }
	/*********************************************************************************/
    public function uninstall(){
        if(!parent::uninstall()){return false;}
        return true;            
    }
	/*********************************************************************************/
	public function hookPayment($params){
		if (!$this->active){return ;}
		return $this->display(__FILE__, 'payment.tpl');
    }
	/*********************************************************************************/
	public function hookPaymentReturn($params){
		if (!$this->active){return ;}
		$newCookie = new Cookie('mahacod');
		$orderid = $newCookie->__get('orderid');
		if (!empty($orderid)){
			$this->smarty->assign(array('status'=> 'ok' ,'orderid' => $orderid,'rahgiri_link'=>'http://mahacod.ir/order_tracking.html?orderid='.$orderid));
		}else{
			$this->smarty->assign(array('status' => 'failed','message' => $newCookie->__get('errormsg')));
		}
		return $this->display(__FILE__, 'payment_return.tpl');
    }
}
